Index: /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1831)
+++ /GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1847)
@@ -235,4 +235,5 @@
 	V = normalize(V);
 	float3 R = normalize(reflect( V, IN.mNormal));
+	//float3 R = normalize(refract( V, IN.mNormal, 0.98));
 		
 	newTexCoord = R;
@@ -280,5 +281,6 @@
 		float3 newX = mPos + R * d;
 		float3 newR = normalize(reflect( newV, newN));
-		
+	//	float3 newR = normalize(refract( newV, newN, 0.98));
+	
 		Hit(newX, newR, DistanceMap, newTexCoord);	
 		Color = readCubeMap(CubeMap, newTexCoord );
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/Common/include/FrameCapture.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/Common/include/FrameCapture.h	(revision 1847)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/Common/include/FrameCapture.h	(revision 1847)
@@ -0,0 +1,205 @@
+#ifndef FRAMECAPTURE_H
+#define FRAMECAPTURE_H
+
+#include "Ogre.h"
+
+using namespace Ogre;
+
+class FrameCapture: public FrameListener
+{
+	class SceneNodeTransformKey
+	{
+	public:
+		Vector3 translate;
+		Quaternion rotation;
+		SceneNode* node;
+
+		SceneNodeTransformKey(SceneNode* node)
+		{
+			this->node = node;
+			translate = node->getPosition();
+			rotation = node->getOrientation();
+		}
+
+		void applyKey()
+		{
+			node->setPosition(translate);
+			node->setOrientation(rotation);
+		}
+	};
+
+	class SceneNodeTransformAnimation
+	{
+	protected:
+
+         std::vector<SceneNodeTransformKey*> keys;
+		 SceneNode* node;
+		 std::vector<SceneNodeTransformKey*>::iterator iter;
+		 std::vector<SceneNodeTransformKey*>::iterator iterEnd;
+	  
+	public: 
+
+		SceneNodeTransformAnimation(SceneNode* node)
+		{
+			this->node = node;
+		}
+		void addKey()
+		{
+			keys.push_back(new SceneNodeTransformKey(node));
+		}
+		void startPlay()
+		{
+			iter = keys.begin();
+			iterEnd = keys.end();
+		}
+		bool stepFrame()
+		{
+			if(iter == iterEnd)
+				return false;
+			
+			(*iter)->applyKey();
+			iter++;
+			return true;
+		}
+		void reset()
+		{
+			keys.clear();
+		}
+	};
+
+protected:
+	std::vector< SceneNodeTransformAnimation*> animables;
+
+public:
+	
+    FrameCapture(RenderTarget* rendertarget)
+	{
+	 target = rendertarget;
+     isPlaying = false;
+	 isRecording = false;
+	 isSaving = false;
+	 framerate = 20;
+	 frameTime = 1000 / framerate;
+	 lastTime = 0;
+	}
+	void addAnimableNode(SceneNode* node)
+	{
+		SceneNodeTransformAnimation* newTrack = new SceneNodeTransformAnimation(node);
+		animables.push_back(newTrack);
+	}
+	void recordEvent()
+	{
+		if(!isRecording && !isPlaying)
+			startRecording();
+		else if(isRecording) stopRecording();
+	}
+	void playEvent()
+	{
+		if(!isRecording && !isPlaying)
+			startPlaying();
+		else if(isPlaying) stopPlaying();
+	}
+	void setSaving(){isSaving = true;}
+	void setFrameRate(int fr)
+	{
+		framerate = fr;
+		frameTime = 1000 / framerate;
+	}
+	
+protected:
+	bool isPlaying;
+	bool isRecording;
+	bool isSaving;
+	int framerate;
+	unsigned long currentFrame;
+	unsigned long frameTime;
+	unsigned long lastTime;
+	RenderTarget* target;
+
+	void startPlaying()
+	{
+		isPlaying = true;
+		std::vector< SceneNodeTransformAnimation*>::iterator iter = animables.begin();
+		std::vector< SceneNodeTransformAnimation*>::iterator iterEnd = animables.end();
+		while(iter != iterEnd)
+		{
+			(*iter)->startPlay();
+			iter++;
+		}
+		currentFrame = 0;
+	}
+	void stopPlaying()
+	{
+		isPlaying = false;
+	}
+	void startRecording()
+	{
+      isRecording = true;
+	  std::vector< SceneNodeTransformAnimation*>::iterator iter = animables.begin();
+	  std::vector< SceneNodeTransformAnimation*>::iterator iterEnd = animables.end();
+	  while(iter != iterEnd)
+	  {
+		  (*iter)->reset();	
+		  iter++;
+	  }
+	}
+	void stopRecording()
+	{
+		isRecording = false;
+	}
+	void play()
+	{
+		std::vector< SceneNodeTransformAnimation*>::iterator iter = animables.begin();
+		std::vector< SceneNodeTransformAnimation*>::iterator iterEnd = animables.end();
+		while(iter != iterEnd)
+		{
+			if(!(*iter)->stepFrame())
+			{
+				isPlaying = false;
+				isSaving = false;
+				return;
+			}
+			iter++;
+		}	
+		currentFrame++;
+	}
+	void record()
+	{
+	  unsigned long thisTime = Root::getSingleton().getTimer()->getMilliseconds();
+      unsigned long timeElapsed = thisTime - lastTime;
+		
+	  if(timeElapsed < frameTime)
+	    return;
+	
+	  lastTime = thisTime;
+	  
+      std::vector< SceneNodeTransformAnimation*>::iterator iter = animables.begin();
+	  std::vector< SceneNodeTransformAnimation*>::iterator iterEnd = animables.end();
+	  while(iter != iterEnd)
+	  {
+		  (*iter)->addKey();
+		  iter++;
+	  }
+	}
+
+	bool frameStarted(const FrameEvent& evt)
+    {	
+		if(isPlaying)
+			play();
+		if(isRecording)
+			record();
+		return true;     
+    }
+	bool frameEnded(const FrameEvent& evt)
+    {	
+		if(isSaving)
+		{
+			String filename = "capture" + StringConverter::toString(currentFrame) + ".tga";
+			target->writeContentsToFile(filename);
+		}
+
+		return true;     
+    }
+};
+
+#endif
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/Common/src/FrameCapture.cpp
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/Common/src/FrameCapture.cpp	(revision 1847)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/Common/src/FrameCapture.cpp	(revision 1847)
@@ -0,0 +1,1 @@
+#include "FrameCapture.h"
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1735)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1847)
@@ -28,5 +28,8 @@
 #include "OgreIlluminationManager.h"
 #include "SpriteParticleRenderer.h"
-
+#include "FrameCapture.h"
+
+int scene = 1;
+FrameCapture* capture;
 
 // Listener class for frame updates
@@ -45,5 +48,19 @@
 		framecount = 0;		
 		this->objectNode = objectNode;
+		
     }
+
+	void moveCamera()
+    {/*
+	   mCamera->yaw(mRotX);
+       mCamera->pitch(mRotY);
+       mCamera->moveRelative(mTranslateVector);*/
+
+		mCamera->getParentSceneNode()->yaw(mRotX, Node::TransformSpace::TS_WORLD);
+		mCamera->getParentSceneNode()->pitch(mRotY, Node::TransformSpace::TS_LOCAL);
+		mCamera->getParentSceneNode()->translate(mTranslateVector, Node::TransformSpace::TS_LOCAL);
+		
+    }
+
 	bool processUnbufferedKeyInput(const FrameEvent& evt)
     {
@@ -124,5 +141,21 @@
             // Move camera down
             mTranslateVector.y = -mMoveScale;
-        }       
+        }
+		if (mInputDevice->isKeyDown(KC_N) && mTimeUntilNextToggle <= 0)
+        {
+			capture->playEvent();
+            mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_B) && mTimeUntilNextToggle <= 0)
+        {
+			capture->recordEvent();
+            mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_M) && mTimeUntilNextToggle <= 0)
+        {
+			capture->setSaving();
+			capture->playEvent();
+            mTimeUntilNextToggle = 1;
+        }
 
         if( mInputDevice->isKeyDown( KC_ESCAPE) )
@@ -198,4 +231,20 @@
 	SceneNode* objectNode;
 
+    void createCamera(void)
+    {
+        // Create the camera
+        mCamera = mSceneMgr->createCamera("PlayerCam");
+		
+		SceneNode* camNode = mSceneMgr->getRootSceneNode()->createChildSceneNode("mainCameraNode");
+		camNode->attachObject(mCamera);
+        camNode->setPosition(Vector3(0,1,0));
+        // Position it at 500 in Z direction
+        //mCamera->setPosition(Vector3(0,0,500));
+        // Look back along -Z
+        //mCamera->lookAt(Vector3(0,0,-300));
+        mCamera->setNearClipDistance(5);
+
+    }
+
 	void createScene(void)
     {
@@ -208,8 +257,10 @@
 		Root::getSingleton()._setCurrentSceneManager(mSceneMgr);
 
-		mCamera->setPosition(0,1,0);		
+		//mCamera->setPosition(0,1,0);		
 		mCamera->setFOVy(Radian(Degree(80)));
 		mCamera->setFarClipDistance(200);
 		mCamera->setNearClipDistance(0.1);
+
+		SceneNode* cn = mCamera->getParentSceneNode();
 
 		OgreIlluminationManager::getSingleton().setFocusingSM(false);
@@ -219,7 +270,16 @@
 	    mSceneMgr->setAmbientLight(ColourValue(0.505 * 0.2, 0.897 * 0.2, 0.914 * 0.2));
 		
-		SceneNode* rootNode = mSceneMgr->getRootSceneNode();
-
-     	Entity* object = mSceneMgr->createEntity("object", "teapot.mesh");
+		capture  = new FrameCapture(mWindow);
+		if(scene == 1) createScene1();
+		if(scene == 2) createScene2();
+
+		OgreIlluminationManager::getSingleton().initTechniques();
+	}
+    
+	void createScene1(void)
+    {
+     	SceneNode* rootNode = mSceneMgr->getRootSceneNode();
+		
+		Entity* object = mSceneMgr->createEntity("object", "teapot.mesh");
 		object->setMaterialName("MetalTeapotMultipleBounce");
 		objectNode = rootNode->createChildSceneNode();
@@ -227,4 +287,60 @@
 		objectNode->scale(0.5,0.5,0.5);
 		//objectNode->scale(0.005,0.005,0.005);
+		objectNode->setPosition(0,1.2,0);
+		objectNode->_updateBounds();
+
+		capture->addAnimableNode(mCamera->getParentSceneNode());
+
+		Entity* room = mSceneMgr->createEntity("scene", "difflab.mesh");
+		//room->setMaterialName("GameTools/Phong");
+		SceneNode* roomNode = rootNode->createChildSceneNode();
+		roomNode->attachObject(room);
+		roomNode->_updateBounds();		
+
+		mSceneMgr->setShadowTechnique(SHADOWTYPE_NONE);
+		Light* redLight1 = mSceneMgr->createLight("RedLight1");
+		redLight1->setType(Light::LT_POINT);
+		redLight1->setCastShadows(false);
+        redLight1->setDiffuseColour(ColourValue(1,0.055, 0.0));
+		redLight1->setPowerScale(1.6);
+		SceneNode* redLightNode1 = rootNode->createChildSceneNode();
+		redLightNode1->setPosition(0.05,2.361,-1.07);
+		redLightNode1->attachObject(redLight1);
+
+		Light* greenLight1 = mSceneMgr->createLight("GreenLight1");
+		greenLight1->setType(Light::LT_POINT);
+		greenLight1->setCastShadows(false);
+        greenLight1->setDiffuseColour(ColourValue(0.362,0.783, 0.685));
+		greenLight1->setPowerScale(2.0);
+		SceneNode* greenLightNode1 = rootNode->createChildSceneNode();
+		greenLightNode1->setPosition(1.312,1.313,0);
+		greenLightNode1->attachObject(greenLight1); 
+
+		Light* mainBlueLight = mSceneMgr->createLight("MainBlueLight");
+		mainBlueLight->setType(Light::LT_SPOTLIGHT);
+		mainBlueLight->setCastShadows(true);
+        mainBlueLight->setDiffuseColour(ColourValue(0.395,0.766, 1.0));
+		mainBlueLight->setPowerScale(5.0);
+		mainBlueLight->setSpotlightRange(Degree(0),Degree(160));
+		mainBlueLight->setAttenuation(2.5, 0, 1, 0);
+		SceneNode* mainBlueLightNode = rootNode->createChildSceneNode();
+		mainBlueLightNode->setPosition(-0.546,2.095,1.035);
+		//mainBlueLightNode->rotate(Vector3::UNIT_X, Degree(161.396));
+		//mainBlueLightNode->rotate(Vector3::UNIT_Y, Degree(53.955));
+		//mainBlueLightNode->rotate(Vector3::UNIT_Z, Degree(-145.065));
+		mainBlueLight->setDirection(-1.5,-2.0,1.0);
+		mainBlueLightNode->attachObject(mainBlueLight);
+   }
+
+	void createScene2(void)
+    {
+     	SceneNode* rootNode = mSceneMgr->getRootSceneNode();
+		
+		Entity* object = mSceneMgr->createEntity("object", "athene.mesh");
+		object->setMaterialName("MetalTeapotMultipleBounce");
+		objectNode = rootNode->createChildSceneNode();
+		objectNode->attachObject(object);
+		//objectNode->scale(0.5,0.5,0.5);
+		objectNode->scale(0.005,0.005,0.005);
 		objectNode->setPosition(0,1.2,0);
 		objectNode->_updateBounds();
@@ -269,7 +385,4 @@
 		mainBlueLight->setDirection(-1.5,-2.0,1.0);
 		mainBlueLightNode->attachObject(mainBlueLight); 
-
-		OgreIlluminationManager::getSingleton().initTechniques();
-
    }
 
@@ -279,5 +392,7 @@
 		mFrameListener= new RaytraceDemoListener(mWindow, mCamera, objectNode);
 		mFrameListener->setPriority(1);
-		OgreIlluminationManager::getSingleton().setPriority(2);
+		OgreIlluminationManager::getSingleton().setPriority(3);
+		capture->setPriority(2);
+        mRoot->addFrameListener(capture);
 		mRoot->addFrameListener(mFrameListener);
 		mRoot->addFrameListener(&OgreIlluminationManager::getSingleton());
Index: /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.vcproj
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.vcproj	(revision 1730)
+++ /GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/scripts/ReflectionTest.vcproj	(revision 1847)
@@ -42,5 +42,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
+				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				MinimalRebuild="true"
@@ -133,5 +133,5 @@
 				OmitFramePointers="true"
 				EnableFiberSafeOptimizations="false"
-				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns"
+				AdditionalIncludeDirectories="..\include;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\include\RenderingRuns;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderTechniques;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\include\RenderingRuns;..\..\Common\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;GAMETOOLS_ILLUMINATION_MODULE"
 				StringPooling="true"
@@ -211,4 +211,12 @@
 			>
 			<File
+				RelativePath="..\..\Common\src\FrameCapture.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\..\Common\include\FrameCapture.h"
+				>
+			</File>
+			<File
 				RelativePath="..\include\ReflectionTest.h"
 				>
Index: /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1735)
+++ /GTP/trunk/App/Demos/Illum/Ogre/bin/Release/ogre.cfg	(revision 1847)
@@ -6,5 +6,5 @@
 Floating-point mode=Fastest
 Full Screen=No
-Rendering Device=NVIDIA GeForce 7950 GX2
+Rendering Device=NVIDIA GeForce 6800 GT
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
Index: /GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 1712)
+++ /GTP/trunk/App/Demos/Illum/Ogre/bin/Debug/ogre.cfg	(revision 1847)
@@ -6,5 +6,5 @@
 Floating-point mode=Fastest
 Full Screen=No
-Rendering Device=NVIDIA GeForce 7950 GX2
+Rendering Device=NVIDIA GeForce 6800 GT
 VSync=No
 Video Mode=800 x 600 @ 32-bit colour
